//node hanaCheck.js 10 > hc.log
const axios = require('axios');
var bunyan = require('bunyan');
var Promise = require("bluebird");
//input
let param = process.argv
console.log('process.argv：\n', param)
const ALLOCATION_LIMIT = param[2]
//end input

const log = bunyan.createLogger({
    name: 'hana',
    streams: [
      {
        level: 'info',
        stream: process.stdout 
      }
    ]
  });

const { Client } = require('pg')
//from CMDB
let cfg = {
    user: 'postgres',
    host: '124.220.100.10',
    database: 'cmdb',
    password: 'postgres',
    port: 40004,
  }
const client = new Client(cfg)

const hana = require('hdb')

async function alertToWechat(msg) {
    let url = 'https://qyapi.weixin.qq.com/cgi-bin/webhook/send?key=870f4aa9-ceab-42e4-a9d6-47b073f77959'
    log.debug(url)
    r = await axios({
        method: 'post',
        url: url,
        data: {
            "msgtype": "text",
            "text": {
                "content": msg
            },
    }
    });
    log.debug(r);
} 

;( async () => {
    
    log.info('read from CMDB') 
    await client.connect()

    let sql = `select * from hana`
    log.info(sql);                     
    let r = await client.query(sql)
    let rows = r.rows
    log.info(JSON.stringify(rows))

    for (let r1 of rows) { //iterate over hana
        log.debug(r1)
        let hanaIp = ''
        let hanaId = ''
        let hanaName = ''
     
        try {
            hanaIp = r1.ip 
            hanaId = r1.id 
            hanaName = r1.name
            let port = r1.port
            let config = {
                "host": hanaIp,
                "port": port,
                "user": "SYSTEM",
                "schema": "SYSTEM",
                "password": "Wang_2017",
            };
            log.debug(JSON.stringify(config));
            const hdbClient = hana.createClient(config);
            Promise.promisifyAll(hdbClient)
            await hdbClient.connectAsync()
            log.debug('hdbClient connectAsync done');

            let sqlMem = "select HOST, round(INSTANCE_TOTAL_MEMORY_USED_SIZE/1024/1024/1024,2) as \"usedMem\",        round(ALLOCATION_LIMIT/1024/1024/1024,2) as \"alloLimitMem\", (round(ALLOCATION_LIMIT/1024/1024/1024,2) - round(INSTANCE_TOTAL_MEMORY_USED_SIZE/1024/1024/1024,2)) as \"allocate\" from M_HOST_RESOURCE_UTILIZATION"
            let r = await hdbClient.execAsync(sqlMem) 
            let usedMem = r[0].usedMem
            let alloLimitMem = r[0].alloLimitMem
            let allocateMem = r[0].allocate
            log.info(`${hanaName}, usedMem: ${usedMem}, alloLimitMem: ${alloLimitMem}, 
            allocateMem: ${allocateMem}`)  
            log.info({'hanaName':hanaName,'usedMem':usedMem,'alloLimitMem':alloLimitMem,'allocateMem':allocateMem})

            if (allocateMem < ALLOCATION_LIMIT ) {
                log.warn(`HANA ${hanaId} used high memory, need release cache`)
                await alertToWechat(`HANA ${hanaId} used high memory, need release cache`)
                sqlMem = 'alter system clear sql plan cache'
                await hdbClient.execAsync(sqlMem) 
            }
           
        } catch (e) {
            log.error(e)
        }
      
    } //for

    log.info('done')    

})().catch(err => log.error(err.stack))