//node hanaExec.js > hc.log
const axios = require('axios');
var bunyan = require('bunyan');
var Promise = require("bluebird");
//input
// let param = process.argv
// console.log('process.argv：\n', param)

//end input

const log = bunyan.createLogger({
    name: 'hanaExec',
    streams: [
      {
        level: 'debug',
        stream: process.stdout 
      }
    ]
  });

const { Client } = require('pg')
//from CMDB
let cfg = {
    user: 'postgres',
    host: '124.220.100.10',
    database: 'cmdb',
    password: 'postgres',
    port: 40004,
  }
const client = new Client(cfg)

const hana = require('hdb')

;( async () => {
    
    log.info('read from CMDB') 
    await client.connect()

    //let sql = `select * from service_info where k8s_namespace = '${k8sNs}'`
    let sql = `select * from hana where env_id = '2'`
    log.info(sql);                     
    let r = await client.query(sql)
    let rows = r.rows
    log.debug(JSON.stringify(rows))

    for (let r1 of rows) { //iterate over hana
        log.debug(r1)
        let ip = ''
        let name = ''
        let port = ''
     
        try {
            ip = r1.ip
            name = r1.name
            port = r1.port?r1.port:'30115'
            log.info(`processing hana ${name}`)
            let config = {
                "host": ip,
                "port": port,
                "user": "SYSTEM",
                "schema": "SYSTEM",
                "password": "Wang_2017",
            };
            log.debug(JSON.stringify(config));
            const hdbClient = hana.createClient(config);
            Promise.promisifyAll(hdbClient)
            await hdbClient.connectAsync()
            log.debug('hdbClient connectAsync done');

            let sql = "SELECT * FROM sys.users"
            let sRows = await hdbClient.execAsync(sql) 

            sRows.forEach(async (r2) => {
                let sn = r2.USER_NAME
                log.info(`processing user ${sn}`)
                if (sn.includes('EXPORT') || sn.includes('SYS') || sn.includes('SYSTEM') || sn.includes('EPM_TMP')  || sn.includes('_AUTO_USER_')) {
                    log.debug('skip')
                } else {
                    let sql1 = `ALTER USER ${sn} DISABLE PASSWORD LIFETIME`
                    log.debug(sql1)
                    await hdbClient.execAsync(sql1)
                    log.info(`processed user ${sn}`)
                }

            })

            // for (let r2 of sRows) {
            //     let sn = r2.USER_NAME
            //     log.info(sn)
            //     try {
            //         if (sn.includes('EXPORT') || sn.includes('SYS') || sn.includes('SYSTEM') || sn.includes('EPM_TMP')  || sn.includes('_AUTO_USER_')) {
            //             log.debug('skip')
            //         } else {
            //             sql = `ALTER USER ${sn} DISABLE PASSWORD LIFETIME`
            //             log.debug(sql)
            //             await hdbClient.execAsync(sql)
            //             log.debug('done1')
            //         }
            //     } catch (e) {
            //         log.error(e)
            //     }
            // }

        } catch (e) {
            log.error(e)
        }      
    } //for

    log.info('done')    

})().catch(err => log.error(err.stack))