//read schema info from CMDB
//history
// epm@cicd3,cd auto_deploy/cmdbCronjob
// node db/hanaExecSqlCmdb.js epmapp true true "upsert git_version values (1,'',null) where id = 1"  | node_modules/.bin/bunyan -o short -L > exec.log 2>&1 &
//update users set misc = '{"failCount":0,"readOnlyRole":{},"startPage":-1,"defaultExpandLevel":1,"singleClickEditing":false,"alwaysShowButtonBar":true,"formatCode":1,"formatPrecision":2,"excelExportBorder":false,"openInw":true,"hideSheetDesc":false,"disableScriptNotif":false,"showErrorDetail":true}' where userid like 'support%' 
// update users set FAIL_COUNT=0 where userid = 'support@keyfunc.com'
// const axios = require('axios');
// var bunyan = require('bunyan');
const vsprintf = require('sprintf-js').vsprintf
var Promise = require("bluebird");
const utils = require('../utils/utils');
const log = utils.createLoggerStdout('hanaExec','debug')

//input
let param = process.argv
console.log('process.argv：\n', param)
const k8sNs = param[2]
const exec = (param[3] === 'true')
const isCons = (param[4] === 'true')
//const sql = param[5]
const sqlFmt = 'grant ALL PRIVILEGES on schema %s to system with grant option'

//end input

const hana = require('hdb')

let hanaTotal = 0
let hanaCnt = 0

//exec sql on specified schema, from cmdb
async function hanaExecSql(client,sql) {
    //only docker hana
    let sqlHanaName = `select distinct(name) as hana_name from schema_info`
    if (k8sNs != 'all') {
      sqlHanaName = sqlHanaName + ` where k8s_namespace='${k8sNs}'`
    }
    log.info(sqlHanaName);                     
    let r = await client.query(sqlHanaName)
    let hanaList = r.rows
    log.debug(hanaList)
    hanaTotal = hanaList.length
  
    hanaList.forEach(async (m) => { //iterate over hana
      let hanaName = ''
      try {
        hanaName = m.hana_name
        let sqlSchema = `select * from schema_info where name = '${hanaName}' and open = true and is_cons = ${isCons}`       
        log.info(sqlSchema);                     
        r = await client.query(sqlSchema)
        let schemaList = r.rows
        log.debug('schemaList',hanaName,schemaList)
  
        for (let r1 of schemaList) { //iterate over schema          
          log.debug(r1)
          let ip = ''
          let hanaName = ''
          let port = ''
          let schemaName = ''
          let backPath = ''
      
          try {             
              schemaName = r1.hana_schema
              backPath = r1.backup_path
              ip = r1.ip
              hanaName = r1.name
              port = r1.port
              let password = r1.schema_password
              log.info(`processing hana ${hanaName}  schemaName ${schemaName}`)
              let config = {
                  "host": ip,
                  "port": port,
                  "user": schemaName,
                  "schema": schemaName,
                  "password": password,
              };
              log.debug(JSON.stringify(config));
              const hdbClient = hana.createClient(config);
              Promise.promisifyAll(hdbClient)
              await hdbClient.connectAsync()
              log.debug('hdbClient connectAsync done');
  
              //log.info(hanaName,sql)
              if (exec) {
                sql =  vsprintf(sql,[schemaName])
                log.info(hanaName,sql)
                await hdbClient.execAsync(sql) 
                log.info(`exec done for hana ${hanaName}, schema ${schemaName}`)
              } else {
                log.debug('skip exec')
              }             
  
          } catch (e) {
              log.error(`exec error for hana ${hanaName}, schema ${schemaName}`,e)
          }         
  
        }//for schema list
        log.info(`exec DB done for hana ${hanaName}`)
        
      } catch (e) {
        log.error(`${hanaName} bad`,e)
      }
  
      if ( ++hanaCnt >= hanaTotal ) {
        log.info(`hana exec all finished`)
        process.exit(0)
      }
    }) //for hanaList.forEach
  
    log.info('exec done async')  
  
  }

;( async () => {
    log.info('read from CMDB') 
    let pgClient = await utils.getCMDBPgClient()

    //let sql = 'update e_proc_step set task_code = task_name'
    await hanaExecSql(pgClient,sqlFmt)

    log.info('done')

})().catch(err => log.error(err.stack))