// prereq: target db is created
//usage node xx.js pgHost pgPort dbname viewOnly replace(whether replace existing schema) init(whether init data)
//cd cmdbCronjob;
// init sys for dev env: node db/system_init_pg.js 192.168.124.191 5433 leontest false true true | node_modules/.bin/bunyan -o short -L > test.log 2>&1
// inuse
//node db/system_init_pg.js www.epmsquare.cn 40007 hjdtest false true true '/home/epm/git_build' | node_modules/.bin/bunyan -o short -L > test.log 2>&1

//only view: 
// node system_init_pg.js www.epmsquare.cn 40005 axent1 true x x | node_modules/.bin/bunyan -o short -L > test.log 2>&1
const bunyan = require('bunyan');
const utils = require('../utils/utils');
const spawnSync = require('child_process').spawnSync;

appName = 'sys-init'
const log = bunyan.createLogger({
    name: appName,
    streams: [       
          {
            level: 'debug',
            stream: process.stdout
          },
    ]
  });

let param = process.argv
log.debug('process.argv：\n', param)


//input params
const pgHost =  param[2]
const pgPort =  param[3]
const dbName = param[4]
const viewOnly = (param[5] == 'true')
const replace = (param[6] == 'true')
const init = (param[7] == 'true')
const gitPath =  param[8] //home/epm/gitbuild
//input params end

//main
;( async () =>{
    log.info('start')

    //update git 
    utils.gitUpdate(`${gitPath}/db`)

    let pgCfg = {
        user: "postgres",
        host: pgHost,
        database: dbName,
        password: "postgres",
        port: pgPort,
    }
     // /usr/pgsql-14/bin/createdb  -h hanatest1.epmtest.cn -p 5432 -U postgres yatal2
     cmd = 'createdb'
     cmdOps = ['-h',pgCfg.host,'-p',pgCfg.port,'-U','postgres',pgCfg.database]
     log.info('PG:creating DB',cmd,cmdOps) //if exist, neglect error
     rsp = spawnSync(cmd, cmdOps,{encoding: 'utf-8', stdio: 'pipe'});    
     log.info(rsp)
    await utils.pgInit(gitPath,pgCfg,viewOnly,replace,init)

    process.exit(0)

})().catch(err => {
    log.error('main exit, ',err.stack)
    process.exit(1)
  })
