const tencentcloud = require("tencentcloud-sdk-nodejs");
const bunyan = require('bunyan');
const { Client } = require('pg')
const { Pool } = require('pg')
//const spawnSync = require('child_process').spawnSync;
const { execSync } = require('node:child_process');
const fs = require('fs');
var pgClient = require('./pgClient');

let sql_dir,pg_sql_dir = ''
const DEFAULT_PASSWD = 'EPM_user_2017'

const uiFilter = ['fudan','cathaya','sinoboom']
const tcrUrl = 'keyfunc.tencentcloudcr.com/prod'

//cicd/tecent
const TcrClient = tencentcloud.tcr.v20190924.Client;
const clientConfig = {
    credential: {
        secretId: "AKIDvnQownMgiTxA7mBJBm69wShfRwA7nDME",
        secretKey: "cy3rOeeMnxqSnreAPM2SbvykLjqjLgkW",
    },
    region: "ap-shanghai",
    profile: {
        httpProfile: {
        endpoint: "tcr.tencentcloudapi.com",
        },
        },
    };

const clientTcr = new TcrClient(clientConfig);

function createLoggerStdout(appName,level) {

    return bunyan.createLogger({
        name: appName,
        streams: [
          {
            level: level,
            stream: process.stdout 
          }
        ]
      });
}

const log = createLoggerStdout('utils','debug')



async function getImage() {
    //get k8simage version
    let appType = 'cons'
    let params = {
        "RegistryId": "tcr-9m984v4t",
        "NamespaceName": "prod",
        "RepositoryName": `${appType}`
    };

    let r = await clientTcr.DescribeImages(params)
    log.debug('DescribeImages:' + JSON.stringify(r));

    let imageVersionList = r.ImageInfoList
    let l = imageVersionList.length
    let targetImageVersionCons = ''
    for (let i = 0;i<l;i++) {
        let img = imageVersionList[i].ImageVersion
        if (img.includes('cons_')) {
            targetImageVersionCons = img
            break
        }
        
    }
    //let targetImageVersionCons = r.ImageInfoList[0].ImageVersion
   
    appType = 'app'
    params = {
        "RegistryId": "tcr-9m984v4t",
        "NamespaceName": "prod",
        "RepositoryName": `${appType}`
    };
    r = await clientTcr.DescribeImages(params)
    log.debug('DescribeImages:' + JSON.stringify(r));

    imageVersionList = r.ImageInfoList
    l = imageVersionList.length

    let targetImageVersionApp = ''
    for (let i = 0;i<l;i++) {
        let img = imageVersionList[i].ImageVersion
        if (img.includes('app_master_')) {
            targetImageVersionApp = img
            break
        }
        
    }

    // params = {
    //     "RegistryId": "tcr-9m984v4t",
    //     "NamespaceName": "prod",
    //     "RepositoryName": 'etl'
    // };

    // r = await clientTcr.DescribeImages(params)
    // let targetImageVersionEtl = r.ImageInfoList[0].ImageVersion
    // log.debug('targetImageVersionEtl:' + targetImageVersionEtl);

    let imageMap = {
        'cons':  `${tcrUrl}/cons:${targetImageVersionCons}`,
        'app':  `${tcrUrl}/app:${targetImageVersionApp}`,
    }
    let imageVersionMap = {
        'cons':  targetImageVersionCons,
        'app':  targetImageVersionApp,
    }

    let imageAry = [imageMap,imageVersionMap]

    log.info(`imageAry: ${JSON.stringify(imageAry)}`)

    return imageAry
}


function gitUpdate(gitRepo) {
  log.info('gitUpdate')
  let cmd = 'git pull'
  let r = execSync(cmd,{cwd: gitRepo})
  log.info(r.toString())
}

async function pgInit(gitPath,pgCfg,viewOnly,replace,init) {
    //try {
     sql_dir =  `${gitPath}/db/`
     pg_sql_dir = `${gitPath}/db/postgre/`

      log.info('pgInit start')

      let pgPool = new Pool(pgCfg)
      log.debug('init pool') 
      log.debug(pgCfg)
      let dbClient = await pgPool.connect()
      log.debug('init dbClient done') 

      if (viewOnly) {

          log.info('only create view')
          await dbClient.query('CREATE EXTENSION IF NOT EXISTS ltree;')
          await readSQLFileInit(log,dbClient,sql_dir + 'consolidationView.sql')
          await readSQLFileInit(log,dbClient,pg_sql_dir +'table.sql')
          await readSQLFileInit(log,dbClient,pg_sql_dir +'functionView.sql')
      } else {

          log.info('init DB')
          if (replace) {
              log.info('replace DB')
              await dbClient.query('drop schema if exists public cascade')
              await dbClient.query('create schema public')
          }
          await dbClient.query('CREATE EXTENSION IF NOT EXISTS ltree;')

          await readSQLFileInit(log,dbClient,sql_dir + 'consolidation.sql')
          await readSQLFileInit(log,dbClient,sql_dir + 'consolidationView.sql')
          await readSQLFileInit(log,dbClient,pg_sql_dir +'table.sql')
          await readSQLFileInit(log,dbClient,pg_sql_dir +'functionView.sql')
          if (init) {
              await readSQLFileInit(log,dbClient,sql_dir + 'initialTables_cons.sql')
          } else {
              log.info('skip init')
          }
      }

      

      log.info('pg init done')

    // } catch (e) {
    //   log.error('main exit, ',e.stack)
      
    // }

}

async function getCMDBPgClient() {
    const cfg = {
        user: 'postgres',
        host: 'hanatest1.epmtest.cn',
        database: 'cmdb',
        password: 'Wang_2023',
        port: 5432,
      }
    let client =  new Client(cfg)
    await client.connect()
    return client

}

//get sql from textfile, then excute it, hana/pg
async function readSQLFileInit(log,dbClient,textfile) {    
    
  log.info('readSQLFileInit:' + textfile)
  let tableAry = []

  const data = fs.readFileSync(textfile, 'UTF-8');
  // split the contents by new line
  const lines = data.split(/\r?\n/);

  // comment mark
  var commentOn = false
  var tblCreate = false

  const commentMark1 = '/*'
  const commentMark2 = '*/'
  const commentMark3 = '--'
  const commentMark4 = '#'

  let objName = ''
  var tblCrtline = ''
  let eol = ';'
        
  for (let line of lines) {
      try {
          
          //filter comment
          if (line.includes(commentMark3) || line.includes(commentMark4) ||
          (line.includes(commentMark1) && line.includes(commentMark2))) {
              continue
          }
          if (line.includes(commentMark1)) {
              commentOn = true
              continue
          }         
          if (commentOn) {
              if (line.includes(commentMark2)) {
                  commentOn = false                
              }
              continue
          }        
          
          var lineUpper = line.toUpperCase().trim();
           //filter invalid lines
           if (lineUpper.includes('DROP TABLE') || lineUpper.includes('DROP VIEW') || lineUpper.includes('DROP VIEW') || lineUpper.includes('GRANT ') || lineUpper == '') {
               continue
           }
                       
          if (!tblCreate) {
              let patt = /CREATE.*TABLE\s+"*(?<tblName>\w+)"*/;
              let patt1 = /CREATE\s+VIEW\s+"*(?<viewName>\w+)"*/;//exclude column view
              let patt2 = /CREATE\s+FUNCTION\s+"*(?<funcName>\w+)"*(?<argName>\(.*\))\s+RETURNS\s+/;
              let patt3 = /CREATE\s+PROCEDURE\s+(?<spName>\w+)\(.*\)/i;
              //CREATE FUNCTION leaves(hname text, q bigint)
              if (patt.test(lineUpper)) {
                  objName = patt.exec(lineUpper).groups.tblName;
                 
                  tblCreate = true 
                  tblCrtline = `drop table if exists "${objName.toLowerCase()}";`
                  eol = ';'
                  //continue              
              } else if (patt1.test(lineUpper)) {
                  //CREATE VIEW V_WORKFLOW_SHEET (
                  objName = patt1.exec(lineUpper).groups.viewName;
                 tblCreate = true 
                 tblCrtline = `drop view if exists "${objName.toLowerCase()}";`
                 eol = ';'
             } else if (lineUpper.startsWith("INSERT INTO") || lineUpper.startsWith("CREATE SEQUENCE")) {
                 //DML initial_cons
                  let sql = pgClient.processSql(line,null)
                  let r = await dbClient.query(sql)
                  log.debug(JSON.stringify(r))
             } else if (patt2.test(lineUpper)) { //funcion
              objName = patt2.exec(lineUpper).groups.funcName;
              let argName = patt2.exec(lineUpper).groups.argName;
              tblCreate = true 
              tblCrtline = `drop function if exists "${objName.toLowerCase()}"${argName};`
              eol = '$$;'
            } else if (patt3.test(lineUpper)) { //procedure
              objName = patt3.exec(lineUpper).groups.spName;
              log.info('procedure')
              tblCreate = true 
              tblCrtline = `drop procedure if exists "${objName.toLowerCase()}"();`
              eol = '$$;'
            } 
          //   else {
          //       log.error(`invalid line ${lineUpper}`)
          //       continue
          //   }
          }
          //create table
          if (tblCreate) {
              //add line
              tblCrtline = tblCrtline + line + '\n'

              //if (line.includes(';')) {
              if ((eol == '$$;' && line.includes(eol)) ) { //function,procedure
                  tblCreate = false  
                  log.debug("create funcion:" + tblCrtline);
                  
                  let r = await dbClient.query(tblCrtline)
                  log.debug(JSON.stringify(r))
                  tblCrtline = ''                                                                  
              } else if ((eol == ';' && line.includes(eol))) {
                  tblCreate = false  
                  log.debug("create table/view(ori):" + tblCrtline);
                
                  let sql = (textfile.includes('table.sql') || textfile.includes('functionView.sql'))? tblCrtline:pgClient.processSql(tblCrtline)
                  let r = await dbClient.query(sql)
                  log.debug(JSON.stringify(r))
                  
                  tblCrtline = ''
              }
              tableAry.push(objName)
          }  
      
      
  } catch (err) {
      log.error(err)
      //log.error(err.stack)
  }
  };//for each line

  let l = tableAry.length
  log.info(`total ${l} object created:`)
  tableAry.sort()

} //readSQLFileAsync

module.exports = {createLoggerStdout,getCMDBPgClient,DEFAULT_PASSWD,readSQLFileInit,pgInit,gitUpdate,getImage}